#import "NSString_JSONExtensions.h"

@interface NSString (NSString_ext)
- (BOOL) endsWith:(NSString*) str;
- (BOOL) startsWith:(NSString*) str;
- (int) indexOfCharacter:(unichar)ch;
- (NSArray*) splitUsing:(NSString*)dstr inclusive:(BOOL)b;
- (NSArray*) split:(NSString*)dstr;
- (NSString*) trim;
- (NSString*) normalizeNL;
- (BOOL) containsCharacter:(unichar) ch;
- (int) lastIndexOfString:(NSString*) str;
- (BOOL) containsString:(NSString*) str;
- (int) indexOfString:(NSString*) str;
- (int) indexOfString:(NSString *)aString options:(unsigned)mask;
- (int) indexOfString:(NSString *)aString from:(unsigned)pos;
- (NSString*) substringBackToIndex:(unsigned)end;
- (NSString*) stringByReplacing:(NSString*)pat with:(NSString*)str;
- (NSString*) stringByReplacingAllMatches:(NSString*)pat with:(NSString*)val;
- (NSString*) substring:(unsigned)start to:(unsigned)end;
- (NSString*) capitalizedFirstChar;
- (int) countOfCharacters:(NSString*) chars;
- (BOOL) isNotEqualToString:(NSString*) str;
- (BOOL) isEqualToStringIgnoringCase:(NSString*) str;
- (BOOL) isWhitespaceCharacterAtIndex:(NSInteger) indx;
+ (NSString*) stringByGeneratingUUID;
+ (NSString*) stringURLEncoded:(NSString *)str;
- (NSString*) decodeURL;
- (BOOL) matches:(NSString*)pat;
- (NSString*) matchFirst:(NSString*)pat;
- (NSArray*) matchAll:(NSString*)pat;
- (NSArray*) matchMultiple:(NSString*)pat;
- (NSString*) stringByExpandingEnv;
- (NSString*) stringByExpanding:(id) env;
- (NSString*) URLEncodedString;
- (NSData*) dataAsUTF8EncodedString;
- (NSString*) md5HexDigest;

#if TARGET_OS_IPHONE
#else
+ (NSString*) stringXMLEncoded:(NSString *)str;
- (NSString*) decodeXML;
- (NSString*) XMLEncodedString;
#endif

- (NSString *)stringByEscapingForHTML;
- (NSString *)stringByEscapingForAsciiHTML;
- (NSString *)stringByUnescapingFromHTML;

@end

